Horizontal Raincloud in JavaScript

Using ApexCharts with JavaScript

This Horizontal Raincloud example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Raw observations per group (Box-Muller Gaussian; Math.random is seeded by
// the sample template). One group is deliberately bimodal: the cloud shows
// the two modes that the box alone would hide, which is the whole point of
// stacking all three layers.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 100) / 100)
  }
  return points
}

var options = {
  series: [
    {
      name: 'Bill ratio',
      data: [
        { x: 'Adelie', points: sample(2.12, 0.16, 150) },
        { x: 'Chinstrap', points: sample(2.65, 0.14, 70) },
        {
          x: 'Gentoo',
          points: sample(3.08, 0.1, 60).concat(sample(3.28, 0.09, 60)),
        },
      ],
    },
  ],
  chart: {
    type: 'raincloud',
    height: 420,
  },
  colors: ['#FE9C64', '#00A29B', '#2E93fA'],
  title: {
    text: 'Bill ratios of three penguin species',
  },
  subtitle: {
    text: 'Horizontal layout: cloud above the axis line, box and rain below',
  },
  plotOptions: {
    bar: {
      horizontal: true,
      distributed: true,
    },
  },
  legend: {
    show: false,
  },
  xaxis: {
    title: {
      text: 'Bill ratio (length / depth)',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Horizontal Raincloud in React

Using ApexCharts with React

This Horizontal Raincloud example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/raincloud'

// Raw observations per group (Box-Muller Gaussian; Math.random is seeded by
// the sample template). One group is deliberately bimodal: the cloud shows
// the two modes that the box alone would hide, which is the whole point of
// stacking all three layers.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 100) / 100)
  }
  return points
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Bill ratio',
        data: [
          { x: 'Adelie', points: sample(2.12, 0.16, 150) },
          { x: 'Chinstrap', points: sample(2.65, 0.14, 70) },
          {
            x: 'Gentoo',
            points: sample(3.08, 0.1, 60).concat(sample(3.28, 0.09, 60)),
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'raincloud',
        height: 420,
      },
      colors: ['#FE9C64', '#00A29B', '#2E93fA'],
      title: {
        text: 'Bill ratios of three penguin species',
      },
      subtitle: {
        text: 'Horizontal layout: cloud above the axis line, box and rain below',
      },
      plotOptions: {
        bar: {
          horizontal: true,
          distributed: true,
        },
      },
      legend: {
        show: false,
      },
      xaxis: {
        title: {
          text: 'Bill ratio (length / depth)',
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="raincloud"
          height={420}
        />
      </div>
    </div>
  )
}

export default ApexChart

Horizontal Raincloud in Angular

Using ApexCharts with Angular

This Horizontal Raincloud example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private sample = (mean: any, sd: any, n: any): any => {
        var points = []
        for (var k = 0; k < n; k++) {
          var u1 = Math.random(),
            u2 = Math.random()
          var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
          points.push(Math.round((mean + g * sd) * 100) / 100)
        }
        return points
      };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Bill ratio',
              data: [
                { x: 'Adelie', points: this.sample(2.12, 0.16, 150) },
                { x: 'Chinstrap', points: this.sample(2.65, 0.14, 70) },
                {
                  x: 'Gentoo',
                  points: this.sample(3.08, 0.1, 60).concat(this.sample(3.28, 0.09, 60)),
                },
              ],
            },
          ],
          chart: {
            type: 'raincloud',
            height: 420,
          },
          colors: ['#FE9C64', '#00A29B', '#2E93fA'],
          title: {
            text: 'Bill ratios of three penguin species',
          },
          subtitle: {
            text: 'Horizontal layout: cloud above the axis line, box and rain below',
          },
          plotOptions: {
            bar: {
              horizontal: true,
              distributed: true,
            },
          },
          legend: {
            show: false,
          },
          xaxis: {
            title: {
              text: 'Bill ratio (length / depth)',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Horizontal Raincloud in Vue

Using ApexCharts with Vue

This Horizontal Raincloud example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="raincloud"
        height="420"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/raincloud'

// Raw observations per group (Box-Muller Gaussian; Math.random is seeded by
// the sample template). One group is deliberately bimodal: the cloud shows
// the two modes that the box alone would hide, which is the whole point of
// stacking all three layers.
function sample(mean, sd, n) {
  var points = []
  for (var k = 0; k < n; k++) {
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(Math.round((mean + g * sd) * 100) / 100)
  }
  return points
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Bill ratio',
          data: [
            { x: 'Adelie', points: sample(2.12, 0.16, 150) },
            { x: 'Chinstrap', points: sample(2.65, 0.14, 70) },
            {
              x: 'Gentoo',
              points: sample(3.08, 0.1, 60).concat(sample(3.28, 0.09, 60)),
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'raincloud',
          height: 420,
        },
        colors: ['#FE9C64', '#00A29B', '#2E93fA'],
        title: {
          text: 'Bill ratios of three penguin species',
        },
        subtitle: {
          text: 'Horizontal layout: cloud above the axis line, box and rain below',
        },
        plotOptions: {
          bar: {
            horizontal: true,
            distributed: true,
          },
        },
        legend: {
          show: false,
        },
        xaxis: {
          title: {
            text: 'Bill ratio (length / depth)',
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 820px;
  margin: 35px auto;
}
</style>